/*

	PRINTDEF.C -- Printer definition tables

	EGAD

	Copyright (c) 1991, 1992 LS Software

	8139 E. Mawson
	Mesa, AZ 85207
	(602) 380-9175

	All Rights Reserved. No part of this program may be reproduced
	in whole or in part without express permission of LS Software.

*/

#include "setegad.h"

PAR_T parMatrixBW = {0,0,0,
	{0,7},			/* palette_2 */
	{0,2,4,7},		/* palette_4 */
	{0,1,2,3,4,5,6,7,4,1,2,3,4,5,6,7}, /* palette_16 */
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};	/* palette_text */

PAR_T parLaserBW = {0,0,0,
	{0,3},			/* palette_2 */
	{0,3,4,7},		/* palette_4 */
	{0,1,2,3,4,5,6,7,4,1,2,3,4,5,6,7}, /* palette_16 */
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};	/* palette_text */

PAR_T parAllColor = {0,0,0,
	{0,42},					/* palette_2 */
	{0,3,12,42},				/* palette_4 */
	{0,11,51,3,60,12,57,42,
	 21,10,34,1,40,8,48,63},		/* palette_16 */
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};	/* text: Needs black cartridge! */

#define X4020

/* Color_Name matches the palette choices below */

char *Color_Name[]={"White","Yellow","Magenta","Red","Cyan","Green",
		    "Blue","Lt.Grey","Dk.Grey","Black"};

/* Available attributes */
char *Text_Name[]={"Normal","Bold","Underline","Italic",
		   "Extra Bold","NLQ","Condensed"};

/* -1 entries means the printer doesn't have that color. */
	/*			  Wh Ye Ma Re Cy Gr Bl G1 G2 Bk */
	int iaPaletteAllColor[]= { 0,48,12,60, 3,51,11,21,42,63};
	int iaPaletteMatrixBW[]= { 0,-1,-1,-1,-1,-1,-1, 2, 4, 7};
	int iaPaletteLaserBW[]=	 { 0,-1,-1,-1,-1,-1,-1, 3, 4, 7};
	int iaPaletteBWOnly[]=   { 0,-1,-1,-1,-1,-1,-1,-1,-1, 7};

	/*			  Wh Ye Ma Re Cy Gr Bl G1 G2 Bk */
	int iaPaletteTextColor[]={-1, 1, 2, 3, 4, 5, 6,-1,-1, 0};

	/*			  No Bo Un It XB NL Cd ?? ?? ?? */
	int iaPaletteTextNorm[]= { 0, 1, 2, 3,-1,-1,-1,-1,-1,-1};
	int iaPaletteTextTosh[]= { 0, 1,-1,-1, 2,-1, 3,-1,-1,-1};
	int iaPaletteTextNEC[]=	 { 0, 1,-1,-1, 2, 3,-1,-1,-1,-1};
	int iaPaletteTextNone[]= { 0,-1,-1,-1,-1,-1,-1,-1,-1,-1};

PRINTER_DEF Epson_DEF =
      {	4129, "Epson FX [most 9-Pin models]", "EP",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parMatrixBW,
	iaPaletteTextNorm,
	iaPaletteMatrixBW
      };

PRINTER_DEF Epson_MXDEF =
      {	4097, "Epson MX", "MX",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parMatrixBW,
	iaPaletteTextNorm,
	iaPaletteMatrixBW
      };

PRINTER_DEF Star_DEF =
      {	4161, "Star SR/SD/SG/Gemini", "ST",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parMatrixBW,
	iaPaletteTextNorm,
	iaPaletteMatrixBW
      };

PRINTER_DEF Epson24_DEF =
      {	12385, "Epson LQ [most 24-Pin models]", "EP24",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parMatrixBW,
	iaPaletteTextNorm,
	iaPaletteMatrixBW
      };

PRINTER_DEF ProPrinter_DEF =
      {	12322, "IBM ProPrinter X24 (AGM -OFF-)", "PP",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parMatrixBW,
	iaPaletteTextNorm,
	iaPaletteMatrixBW
      };

PRINTER_DEF EpsonC_DEF =
      {	5665, "Epson Color [9-Pin]", "EPC",
	P_COLORS_OTHER,P_TEXT_COLOR,
	&parAllColor,
	iaPaletteTextColor,
	iaPaletteAllColor
      };

PRINTER_DEF ProPrinterC_DEF =
      {	13857, "Epson LQ Color [24-pin]", "LQC",
	P_COLORS_OTHER,P_TEXT_COLOR,
	&parAllColor,
	iaPaletteTextColor,
	iaPaletteAllColor
      };

PRINTER_DEF Toshiba_DEF =
      {	12291, "Toshiba 3x1/13x1 24-pin", "TOSH",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parMatrixBW,
	iaPaletteTextTosh,
	iaPaletteMatrixBW
      };

PRINTER_DEF Oki292_DEF =
      {	5798, "Okidata 292", "O292",
	P_COLORS_OTHER,P_TEXT_COLOR,
	&parAllColor,
	iaPaletteTextColor,
	iaPaletteAllColor
      };

PRINTER_DEF HPPaintJet_DEF =
      {	17056, "HP PaintJet", "PJ",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parAllColor,
	iaPaletteTextNorm,
	iaPaletteAllColor
      };

PRINTER_DEF HPDeskJet500_DEF =
      {	16576, "HP DeskJet 500", "DJ5",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parLaserBW,
	iaPaletteTextNorm,
	iaPaletteLaserBW
      };

PRINTER_DEF HPDeskJet500C_DEF =
      {	17088, "HP DeskJet 500C/550C", "DJ5C",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parAllColor,
	iaPaletteTextNorm,
	iaPaletteAllColor
      };

PRINTER_DEF HPLaserJet_DEF =
      {	2048, "HP LaserJet", "HP",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parLaserBW,
	iaPaletteTextNorm,
	iaPaletteLaserBW
      };

PRINTER_DEF HPLaserJet2_DEF =
      {	2080, "HP LaserJet Series II", "HP2",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parLaserBW,
	iaPaletteTextNorm,
	iaPaletteLaserBW
      };

PRINTER_DEF HPLaserJet3_DEF =
      {	2144, "HP DeskJet, LaserJet IIP/III/4", "HP3",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parLaserBW,
	iaPaletteTextNorm,
	iaPaletteLaserBW
      };

PRINTER_DEF PCPILaser_DEF =
      {	2056, "PCPI LaserImage 2000", "PCPI",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parLaserBW,
	iaPaletteTextNorm,	/* actually PCPI doesn't do italics... */
	iaPaletteLaserBW
      };

PRINTER_DEF PostScript_DEF =
      {	2091, "PostScript", "POST",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parLaserBW,
	iaPaletteTextNorm,
	iaPaletteLaserBW
      };

PRINTER_DEF CPostScript_DEF =
      {	2635, "Color PostScript", "PSC",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parAllColor,
	iaPaletteTextNorm,
	iaPaletteAllColor
      };

PRINTER_DEF Xerox_DEF =
      {	17929, "Xerox 4020 Inkjet", "XE",
	P_COLORS_OTHER,P_TEXT_COLOR, /* |P_TEXT_BG_COLOR */
	&parAllColor,
	iaPaletteTextColor,
	iaPaletteAllColor
      };

PRINTER_DEF NEC_DEF =
      {	4100, "NEC 8023/C.Itoh 8510", "NEC",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parMatrixBW,
	iaPaletteTextNEC,
	iaPaletteMatrixBW
      };

PRINTER_DEF DPColor_DEF =
      {	5669, "Dataproducts 8050", "DP",
	P_COLORS_OTHER,P_TEXT_COLOR,
	&parAllColor,
	iaPaletteTextColor,
	iaPaletteAllColor
      };

PRINTER_DEF DPTiger_DEF =
      {	4101, "Paper Tiger", "PT",
	P_COLORS_ONLY,P_TEXT_NONE,
	&parMatrixBW,
	iaPaletteTextNone,
	iaPaletteBWOnly
      };

PRINTER_DEF Oki_DEF =
      {	4102, "Okidata 82/83/92/93", "OKI",
	P_COLORS_ONLY,P_TEXT_NONE,
	&parMatrixBW,
	iaPaletteTextNone,
	iaPaletteBWOnly
      };

PRINTER_DEF MPI_DEF =
      {	4103, "MPI 88G/99G/150", "MPI",
	P_COLORS_ONLY,P_TEXT_NONE,
	&parMatrixBW,
	iaPaletteTextNone,
	iaPaletteBWOnly
      };

PRINTER_DEF IBMJet_DEF =
      {	16962, "IBM Color Jet 3852", "IBJ",
	P_COLORS_ONLY,P_TEXT_COLOR,
	&parAllColor,
	iaPaletteTextColor,
	iaPaletteAllColor
      };

PRINTER_DEF HPQuietJet_DEF =
      {	16448, "HP QuietJet", "QJ",
	P_COLORS_OTHER,P_TEXT_ATTRS,
	&parLaserBW,
	iaPaletteTextNorm,
	iaPaletteLaserBW
      };

PRINTER_DEF DMP_DEF =
      {	4106, "Radio Shack DMP-105", "DMP",
	P_COLORS_ONLY,P_TEXT_ATTRS,
	&parMatrixBW,
	iaPaletteTextNEC,
	iaPaletteTextNone
      };

PRINTER_DEF CGP220_DEF =
      {	17962, "Radio Shack CGP-220", "CGP",
	P_COLORS_ONLY,P_TEXT_COLOR,
	&parAllColor,
	iaPaletteTextColor,
	iaPaletteAllColor
      };

PRINTER_DEF *characteristics[]=
  {
	/* Dot-Matrix */

   &Epson_DEF,
   &Star_DEF,
   &Epson_MXDEF,
   &Epson24_DEF,
   &ProPrinter_DEF,
   &EpsonC_DEF,&ProPrinterC_DEF,
   &Toshiba_DEF,
   &NEC_DEF,&DPColor_DEF,
   &DPTiger_DEF,&Oki_DEF,
   &MPI_DEF,&DMP_DEF,
   &Oki292_DEF,

	/* Lasers */

   &HPLaserJet_DEF,
   &HPLaserJet2_DEF,
   &HPLaserJet3_DEF,
   &PCPILaser_DEF,
   &PostScript_DEF,
   &CPostScript_DEF,

	/* Ink Jet */

   &HPPaintJet_DEF,
   &HPQuietJet_DEF,
   &HPDeskJet500C_DEF,
   &HPDeskJet500_DEF,
   &Xerox_DEF,
   &IBMJet_DEF,&CGP220_DEF
  };

#define NPRINTERS sizeof(characteristics)/sizeof(PRINTER_DEF *)

int nprinters=NPRINTERS;

